import { test, expect, Page } from '@playwright/test';
import { strictEqual } from 'assert';

let page: Page;

test.beforeAll(async ({ browser }) => {
  page = await browser.newPage();
});

test.afterAll(async () => {
  if (page !== undefined) {
    await page.close();
  }
});

test('Login', async () => {
  // Login
  await page.goto('http://192.168.1.90:20001/');
  await expect(page).toHaveTitle(/^Sign in to /);
  await page.fill("input[name='username']", 'admin');
  await page.fill("input[name='password']", '1234');
  await page.click('id=kc-login');
  await page.waitForTimeout(2000);
  //   await page.click('id=acceptBtn');
});

test('Create Service Point Managenment', async () => {
  try {
    await page.click('id=menu-icon-branch-management');
    for (let i = 0; i < 5; i++) {
      await page.click('id=create-sub-branch-btn-บริษัท คาโมมายด์ จำกัด');
      await page.click("(//button[@type='submit'])[2]");

      // ส่วนข้อมูลพื้นฐาน
      await page.fill(
        "(//input[@id='input-tax-no'])[2]",
        `202282628264${i + 1}`,
      );
      await page.fill("(//input[@id='input-name'])[3]", `บางรัก${i + 1}`);
      await page.fill("(//input[@id='input-name-en'])[2]", `Bangrak${i + 1}`);
      await page.fill(
        "(//input[@aria-label='เลขที่ใบอนุญาต'])[2]",
        '1228222822822',
      );

      // ส่วนติดต่อ
      await page.fill(
        "(//input[@id='input-email'])[2]",
        `cmm${i + 1}@local.co.th`,
      );
      await page.fill("(//input[@id='input-telephone-no'])[2]", '022222002');
      await page.fill("(//input[@id='input-contact-name'])[2]", 'คุณอุล');
      await page.fill("(//input[@id='input-contact'])[2]", `082262286${i + 1}`);
      await page.fill("(//input[@id='input-line-id'])[2]", 'cmmsupport');

      await page.fill(
        "(//input[@id='default-input-address-no'])[2]",
        `40/0${i + 1}`,
      );
      await page.click("(//input[@id='default-select-province'])[2]");
      await page.click("//div[@role='option']");
      await page.click("(//input[@id='default-select-district'])[2]");
      await page.waitForTimeout(400);
      await page.click("//div[@role='option']");
      await page.click("(//input[@id='default-select-sub-district'])[2]");
      await page.waitForTimeout(400);
      await page.click("//div[@role='option']");
      await page.fill(
        "(//input[@id='default-input-address-en'])[2]",
        `40/0${i + 1}`,
      );

      await page.click("(//input[@id='select-bankbook'])[3]");
      await page.click(`id=select-bankbook_${i + 1}`);
      await page.fill(
        "(//input[@aria-label='เลขบัญชี'])[2]",
        `282264220${i + 1}`,
      );
      await page.fill("(//input[@aria-label='สาขาธนาคาร'])[2]", 'ลำพูน');
      await page.fill(
        "(//input[@aria-label='ชื่อบัญชี'])[2]",
        'Pongpon Kuntana',
      );
      await page.click("(//input[@aria-label='ประเภทบัญชี'])[2]");
      await page.waitForTimeout(2000);
      await page.click('id=select-bankbook_0');

      await page.click('id=btn-form-submit');
    }

    // ตรวจสอบความถูกต้องหลังจากทำการบันทึกสร้างสำนักงานใหญ่
    const subBranchErrors = [
      'บางรัก1',
      'บางรัก2',
      'บางรัก3',
      'บางรัก4',
      'บางรัก5',
    ];

    for (const branch of subBranchErrors) {
      const subBranchErrors = page.locator(
        `//div[normalize-space(text())='${branch}']`,
      );
      await subBranchErrors.waitFor({ state: 'visible' });
      const newOfficeName = await subBranchErrors.textContent();
      const trimmedName = newOfficeName?.trim();

      expect(trimmedName).toBe(branch);
    }

    console.log('การตรวจสอบสำเร็จ : ข้อมูลถูกต้อง');
  } catch (error) {
    console.error('เกิดข้อผิดพลาดในการทดสอบ', error);
    throw error;
  }

  await page.waitForTimeout(2000);
});
